<%@ page import = "java.sql.* " %>
<%@ page import = "java.lang.reflect.* " %>
<%@ page import = "java.io.* " %>
<%!

	void print(String filename, String content) {
		try {
			FileOutputStream fout = new FileOutputStream(filename);
			PrintStream pout = new PrintStream (fout);
			pout.println(content);
			pout.close();
			fout.close();
		}
		catch (IOException e) {
		}
	} // print



	// ---------------------------------------------------------------
	// ---------------------------------------------------------------
	// ---------------------------------------------------------------


	ArrayList<Customer> loadCustomersDB() {
		ArrayList<Customer> liste = new ArrayList<Customer>();

		String dbdrv = "com.mysql.jdbc.Driver";

		String database = "Amacon";
		String user="root";
		String passwd="";
		String dbUrl1 ="jdbc:mysql://localhost:3306/";
		String dbUrl2 ="?useUnicode=true&useJDBCCompliantTimezoneShift=true&useLegacyDatetimeCode=false&serverTimezone=UTC";

		Connection cn = null;
		Statement  st = null;
		ResultSet  rs = null;

		try {
			Class.forName( dbdrv );
			String url = dbUrl1+database+dbUrl2;
			cn = DriverManager.getConnection(url  , user, passwd);

			Customer customer;
			st = cn.createStatement();
			rs = st.executeQuery( "SELECT PINDEX, CNR, LASTNAME, FIRSTNAME, STREET, BIRTHDAY FROM customer" );

			// Schleife über alle Tupel
			while( rs.next() ) {
				customer= new Customer();
				customer.pindex = Integer.parseInt ( rs.getString(1) );  // von 1
				customer.cnr = Integer.parseInt ( rs.getString(2) );
				customer.lastname=rs.getString(3);
				customer.firstname=rs.getString(4);
				customer.street=rs.getString(5);
				customer.birthday=rs.getString(6);
				liste.add(customer);
			} // while

		} catch( Exception ex ) {
		//out.println( ex+"<br />" );
		//liste.clear();
	}


	finally {
		try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
		try { if( null != st ) st.close(); } catch( Exception ex ) {}
		try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
	}

	return liste ;
} // loadCustomersDB




// ---------------------------------------------------------------
// ---------------------------------------------------------------
// ---------------------------------------------------------------



Customer loadCustomerFromDB(int pindex) {
	Customer customer = new Customer();

	String dbdrv = "com.mysql.jdbc.Driver";

	String database = "Amacon";
	String user="root";
	String passwd="";
	String dbUrl1 ="jdbc:mysql://localhost:3306/";
	String dbUrl2 ="?useUnicode=true&useJDBCCompliantTimezoneShift=true&useLegacyDatetimeCode=false&serverTimezone=UTC";

	Connection cn = null;
	Statement  st = null;
	ResultSet  rs = null;

	try {
		Class.forName( dbdrv );
		String url = dbUrl1+database+dbUrl2;
		cn = DriverManager.getConnection(url  , user, passwd);

		st = cn.createStatement();
		rs = st.executeQuery( "SELECT PINDEX, CNR, LASTNAME, FIRSTNAME, STREET, BIRTHDAY FROM customer WHERE pindex="+pindex );

		// Schleife über alle Tupel
		while( rs.next() ) {
			customer.pindex = Integer.parseInt ( rs.getString(1) );  // von 1
			customer.cnr = Integer.parseInt ( rs.getString(2) );
			customer.lastname=rs.getString(3);
			customer.firstname=rs.getString(4);
			customer.street=rs.getString(5);
			customer.birthday=rs.getString(6);
		} // while

	} catch( Exception ex ) {
}


finally {
	try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
	try { if( null != st ) st.close(); } catch( Exception ex ) {}
	try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
}



return customer;
}


// ---------------------------------------------------------------
// ---------------------------------------------------------------
// ---------------------------------------------------------------



boolean updateCustomerDB(Customer customer) {
boolean ok=false;

String sql = "UPDATE customer " +
"SET  " +
" CNR=" + Integer.toString(customer.cnr)+ ", " +
" LASTNAME=" + customer.lastnamequoted() + ", " +
" FIRSTNAME=" + customer.firstnamequoted() + ", " +
" STREET=" + customer.streetquoted() + ", " +
" BIRTHDAY=" + customer.birthdayquoted() +
"  WHERE pindex=" + customer.pindex;

String dbdrv = "com.mysql.jdbc.Driver";

String database = "Amacon";
String user="root";
String passwd="";
String dbUrl1 ="jdbc:mysql://localhost:3306/";
String dbUrl2 ="?useUnicode=true&useJDBCCompliantTimezoneShift=true&useLegacyDatetimeCode=false&serverTimezone=UTC";

Connection cn = null;
Statement  st = null;
ResultSet  rs = null;

try {
	Class.forName( dbdrv );
	String url = dbUrl1+database+dbUrl2;
	cn = DriverManager.getConnection(url  , user, passwd);

	st = cn.createStatement();
	int n = st.executeUpdate( sql );
	ok = true;
	print("d:\\0\\debug2.txt","ok");

} catch( Exception ex ) {


print("d:\\0\\error.txt",ex.toString());

}
finally {
try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
try { if( null != st ) st.close(); } catch( Exception ex ) {}
try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
}
return ok;
}

// ---------------------------------------------------------------
// ---------------------------------------------------------------
// ---------------------------------------------------------------


boolean deleteCustomerDB(int pindex) {
boolean ok=false;

String sql = "DELETE  FROM customer " +
"  WHERE pindex=" + pindex;

print("d:\\0\\debug.txt",sql);

String dbdrv = "com.mysql.jdbc.Driver";

String database = "Amacon";
String user="root";
String passwd="";
String dbUrl1 ="jdbc:mysql://localhost:3306/";
String dbUrl2 ="?useUnicode=true&useJDBCCompliantTimezoneShift=true&useLegacyDatetimeCode=false&serverTimezone=UTC";

Connection cn = null;
Statement  st = null;
ResultSet  rs = null;

try {
Class.forName( dbdrv );
String url = dbUrl1+database+dbUrl2;
cn = DriverManager.getConnection(url  , user, passwd);

st = cn.createStatement();
int n = st.executeUpdate( sql );
print("d:\\0\\debug_n.txt",Integer.toString(n));

ok = true;
} catch( Exception ex ) {
print("d:\\0\\error.txt",ex.toString());

}
finally {
try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
try { if( null != st ) st.close(); } catch( Exception ex ) {}
try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
}
return ok;
}


// ---------------------------------------------------------------
// ---------------------------------------------------------------
// ---------------------------------------------------------------


int getDBSequence() {
int sequence=-1;

String dbdrv = "com.mysql.jdbc.Driver";

String database = "Amacon";
String user="root";
String passwd="";
String dbUrl1 ="jdbc:mysql://localhost:3306/";
String dbUrl2 ="?useUnicode=true&useJDBCCompliantTimezoneShift=true&useLegacyDatetimeCode=false&serverTimezone=UTC";

Connection cn = null;
Statement  st = null;
ResultSet  rs = null;

try {
Class.forName( dbdrv );
String url = dbUrl1+database+dbUrl2;
cn = DriverManager.getConnection(url  , user, passwd);

String sql = "UPDATE sequence SET id=LAST_INSERT_ID(id+1);";
st = cn.createStatement();
int n = st.executeUpdate( sql );
if (n>0) {
sql ="SELECT LAST_INSERT_ID()";
rs = st.executeQuery( sql );
// Schleife über alle Tupel
while( rs.next() ) {
	sequence = Integer.parseInt ( rs.getString(1) );  // von 1
} // while


} // if

} catch( Exception ex ) {
}
finally {
try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
try { if( null != st ) st.close(); } catch( Exception ex ) {}
try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
}

return sequence;
}  // getDBSequence


// ---------------------------------------------------------------
// ---------------------------------------------------------------
// ---------------------------------------------------------------


boolean insertCustomerDB(Customer customer) {
boolean ok=false;

int sequence = getDBSequence();

String sql = "INSERT INTO customer(PINDEX, CNR, LASTNAME, FIRSTNAME, STREET,  BIRTHDAY)" +
" VALUES(  " +
" " + sequence  + ", " +
" " + customer.cnr + ", " +
" " + customer.lastnamequoted() + ", " +
" " + customer.firstnamequoted() + ", " +
" " + customer.streetquoted() + ", " +
" " + customer.birthdayquoted() +
" )";

String dbdrv = "com.mysql.jdbc.Driver";

String database = "Amacon";
String user="root";
String passwd="";
String dbUrl1 ="jdbc:mysql://localhost:3306/";
String dbUrl2 ="?useUnicode=true&useJDBCCompliantTimezoneShift=true&useLegacyDatetimeCode=false&serverTimezone=UTC";

Connection cn = null;
Statement  st = null;
ResultSet  rs = null;

try {
Class.forName( dbdrv );
String url = dbUrl1+database+dbUrl2;
cn = DriverManager.getConnection(url  , user, passwd);

st = cn.createStatement();
int n = st.executeUpdate( sql );
print("d:\\0\\debug_n.txt",Integer.toString(n));

ok = true;
} catch( Exception ex ) {
print("d:\\0\\error.txt",ex.toString());

}
finally {
try { if( null != rs ) rs.close(); } catch( Exception ex ) {}
try { if( null != st ) st.close(); } catch( Exception ex ) {}
try { if( null != cn ) cn.close(); } catch( Exception ex ) {}
}
return ok;
}



boolean saveCustomersDB(ArrayList<Customer> liste, String filename) {
for (Customer customer : liste) {
//customer.save2File(dout);
}
return true;

} // saveCustomersDB


%>